#include <string.h>

#include "http_loop.h"

void http_loop_process_request(event_loop_conn *conn) {
  http_loop_ctx *ctx = conn->ctx;

  // The end of the list of steps is marked with a NULL. When this is reached,
  // we simply set the route to NULL, letting the http loop know a new request
  // can be handled.
  if (ctx->route->steps[ctx->current_step] == NULL) {
    ctx->route = NULL;
    ctx->current_step = 0;
    return;
  }

  // We execute the next step
  // NOTE can/should we execute more than one step at once here?
  if (ctx->route->steps[ctx->current_step](conn)) {
    ctx->current_step++;
  }
}

bool http_loop_route_request(event_loop_conn *conn) {
  http_loop_ctx *ctx = conn->ctx;
  http_loop_gctx *gctx = ctx->g;

  http_route *route;

  for (size_t i = 0; i < gctx->route_count; i++) {
    route = &gctx->routes[i];

    switch (route->type) {
    case http_route_literal:
      if (strncmp(route->path, ctx->req.method, ctx->req.method_len)) {
        ctx->route = route;
        return true;
      }
    // TODO
    case http_route_regex:;
    }
  }

  // Fallthrough is to write a 404
  http_write_standard_response(conn, http_not_found);

  return false;
}
